<?php

namespace Exception;

class Login {
    public static function userNotFound() {
        throw new CustomException('USER_NOT_FOUND', 1);
    }

    public static function userInactive() {
        throw new CustomException('USER_INACTIVE', 2);
    }

    public static function invalidPassword() {
        throw new CustomException('INVALID_PASSWORD', 5);
    }

    public static function accessDenied() {
        throw new CustomException('ACCESS_DENIED', 6);
    }

    public static function invalidADCredentials() {
        throw new CustomException('INVALID_AD_CREDENTIALS', 9);
    }

    public static function notConnectAD() {
        throw new CustomException('NOT_CONNECT_AD', 10);
    }

    public static function notUpdatePasswordAD() {
        throw new CustomException('NOT_UPDATE_PASSWORD_AD', 11);
    }

    public static function userNotFoundAD() {
        throw new CustomException('NOT_FOUND_USER_AD', 12);
    }

    public static function userNotOrganization() {
        throw new CustomException('USER_NOT_ORGANIZATION', 14);
    }

    public static function productIdNotFound() {
        throw new CustomException('PRODUCT_ID_NOT_FOUND', 16);
    }

    public static function errorUseLocalHost() {
        throw new CustomException('DONT_USE_LOCALHOST', 18);
    }

    public static function requesterUrlNotFound() {
        throw new CustomException('REQUESTER_URL_NOT_FOUND', 19);
    }

    public static function userInformationNotFound() {
        throw new CustomException('USER_INFORMATION_NOT_FOUND', 20);
    }

    public static function authenticateUserError() {
        throw new CustomException('ERR_REQUEST_LOGIN_USER_DATA', 50);
    }

    public static function orgAccessDecryptFail() {
        throw new CustomException('ORG_ACCESS_DECRYPT_FAIL', 21);
    }

    public static function productIsNotAvailable() {
        throw new CustomException('PRODUCT_IS_NOT_AVAILABLE', 22);
    }

    public static function menuItemsNotFound() {
        throw new CustomException('MENU_ITEMS_NOT_FOUND', 23);
    }

    public static function productDateExpired() {
        throw new CustomException('PRODUCT_DATE_EXPIRED', 24);
    }

    public static function ipIsOutOfRange($ip) {
        throw new CustomException('ERR_IP_IS_OUT_OF_RANGE', 25, array( 'ip' => $ip ));
    }

    public static function userNotAccessProfile() {
        throw new CustomException('USER_NOT_ACCESS_PROFILE', 26);
    }

    public static function invalidDomain() {
        throw new CustomException('INVALID_DOMAIN', 27);
    }

    public static function productIsNotAuthorized() {
        throw new CustomException('PRODUCT_IS_NOT_AUTHORIZED', 28);
    }

    public static function invalidPasswordBlockUser() {
        throw new CustomException('INVALID_PASSWORD_BLOCK_USER', 29);
    }

    public static function accessBlocked() {
        throw new CustomException('ACCESS_BLOCKED', 30);
    }

    public static function accessBlockedByAttempts() {
        throw new CustomException('ACCESS_BLOCKED_BY_ATTEMPTS', 31);
    }

    public static function invalidPasswordCode32() {
        throw new CustomException('INVALID_PASSWORD', 32);
    }

    public static function passwordNotReused($changesToReuse) {
        throw new CustomException('PASSWORD_NOT_REUSED', 33, array( 'changes' => $changesToReuse ));
    }

    public static function incorrectMacAddressOAccCustom() {
        throw new CustomException('INCORRECT_MAC_ADDRESS_OACC_CUSTOM', 34);
    }

    public static function concurrentAccess() {
        throw new CustomException('ALE_CONCURRENT_ACCESS', 35);
    }

    public static function incorrectDbHostInfo() {
        throw new CustomException('INCORRECT_DB_HOST_INFO_OACC_CUSTOM', 34);
    }

    public static function expirationDatePer() {
        throw new CustomException('EXPIRATION_DATE_PER', 36);
    }

    public static function expiredTokenSupportOperator() {
        throw new CustomException('EXPIRED_SESSION_SUPPORT_OPERATOR', 102);
    }

    public static function inactiveOrganization() {
        throw new CustomException('INACTIVE_ORGANIZATION', 105);
    }

    public static function accessBlockedByTime($hrIni, $hrEnd) {
        throw new CustomException('ACCESS_BLOCKED_BY_TIME', 37, array( 'hrIni' => $hrIni, 'hrEnd' => $hrEnd ));
    }

    public static function accessBlockedByDay() {
        throw new CustomException('ACCESS_BLOCKED_BY_DAY', 38);
    }

    public static function emptyAccessRule() {
        throw new CustomException('EMPTY_ACCESS_RULE', 39);
    }

    public static function invalidKey() {
        throw new CustomException('ERR_INVALID_KEY', 40);
    }

    public static function expiredKey() {
        throw new CustomException('ERR_EXPIRED_KEY', 41);
    }

    public static function attemptsKey() {
        throw new CustomException('ERR_ATTEMPTS_MORE_KEY', 41);
    }
} 