<?php

namespace Factory;

use Teknisa\Model\Geral\Entities\Paramsenha as ParamsenhaEntity;
use Util\Utilities;

class ParamSenha {
    /** @var Utilities $utilities */
    private $utilities;

    /**
     * @param Utilities $utilities
     */
    public function __construct(Utilities $utilities) {
        $this->utilities = $utilities;
    }

    /**
     * @param $paramSenha
     * @param $nrOrg
     * @param $cdOperador
     * @param $domain
     * @param $server
     * @param $admUser
     * @param $admPassword
     * @param $useAd
     * @return \Teknisa\Model\Geral\Entities\Paramsenha
     */
    public function saveADConfiguration($paramSenha, $nrOrg, $cdOperador, $domain, $server, $admUser, $admPassword, $useAd) {
        $currentDate = $this->utilities->getCurrentDate();
        $useAd = $useAd == 'Y' ? 'S' : 'N';
        if(!$paramSenha) {
            $paramSenha = new ParamsenhaEntity();
            $paramSenha->setNrorginclusao($nrOrg);
            $paramSenha->setDtinclusao($currentDate);
            $paramSenha->setCdoperinclusao($cdOperador);
        }

        $paramSenha->setNrorg($nrOrg);
        $paramSenha->setDtultatu($currentDate);
        $paramSenha->setNrorgultatu($nrOrg);
        $paramSenha->setCdoperultatu($cdOperador);
        $paramSenha->setNmdominioad($domain);
        $paramSenha->setDsurlserverad($server);
        $paramSenha->setNmusuarioadmad($admUser);
        $paramSenha->setIdutilizaad($useAd);

        if($admPassword != ParamsenhaEntity::DEFAULT_ADM_PASSWORD) {
            $admPassword = empty($admPassword) ? null : \Teknisa\Libs\Util\Utilities::zeedhiEncrypt($admPassword);
            $paramSenha->setDssenhausuarioadmad($admPassword);
        }

        return $paramSenha;
    }

    /**
     * @param $paramSenha
     * @param $idUtCtrlSen
     * @param $nrDiasExpSen
     * @param $nrDiasAviso
     * @param $nrAltSenhRep
     * @param $cdPictSenha
     * @param $nrErroSenha
     * @param $nrOrg
     * @param $cdOperador
     * @return ParamsenhaEntity
     */
    public static function savePasswordParams($paramSenha, $idUtCtrlSen, $nrDiasExpSen, $nrDiasAviso,
                                              $nrAltSenhRep, $cdPictSenha, $nrErroSenha, $nrOrg, $cdOperador, $idutctrlfac,
                                              $nrtepcodaut, $nrtenautcha) {
        $currentDate = Utilities::getCurrentDate();
        if(!$paramSenha) {
            $paramSenha = new ParamsenhaEntity();
            $paramSenha->setNrorginclusao($nrOrg);
            $paramSenha->setDtinclusao($currentDate);
            $paramSenha->setCdoperinclusao($cdOperador);
        }

        $paramSenha->setNrorg($nrOrg);
        $paramSenha->setDtultatu($currentDate);
        $paramSenha->setNrorgultatu($nrOrg);
        $paramSenha->setCdoperultatu($cdOperador);

        $paramSenha->setIdutctrlsen($idUtCtrlSen);
        $paramSenha->setNrdiasexpsen($nrDiasExpSen);
        $paramSenha->setNrdiasaviso($nrDiasAviso);
        $paramSenha->setNraltsenhrep($nrAltSenhRep);
        $paramSenha->setCdpictsenha($cdPictSenha);
        $paramSenha->setNrerrosenha($nrErroSenha);
        $paramSenha->setIdutctrlfac($idutctrlfac);
        $paramSenha->setNrtepcodaut($nrtepcodaut);
        $paramSenha->setNrtenautcha($nrtenautcha);
        return $paramSenha;
    }
} 